﻿Class MPEG4Info
    Private FileName As String = ""     ' Pfad zur Datei
    Private ILST() As Byte              ' Byte Array für die Box ILST
    Private cDay() As Byte              ' Byte Array für die Box ©day
    Private cArt() As Byte              ' Byte Array für die Box ©art
    Private cAlb() As Byte              ' Byte Array für die Box ©alb
    Private cNam() As Byte              ' Byte Array für die Box ©nam
    Private cGen() As Byte              ' Byte Array für die Box ©gen/gnre

    Sub New(ByVal File As String)
        FileName = File

        ' Auslesen der Box ILST
        ILST = ReadBox("ilst")
    End Sub

    ' Hier wird eine Box aus der Datei in ein Byte-Array eingelesen 
    Private Function ReadBox(ByVal BoxName As String) As Byte()
        Dim ReturnBytes() As Byte
        Dim FileStram As New IO.FileStream(FileName, IO.FileMode.Open)
        Dim TempArr(3) As Byte
        Dim Pos As Long
        Dim TempString As String = ""
        Dim Len As Long

        ' Hier wird jede 4er-Bytekette im Filestream nach dem Boxnamen 
        '  durchsucht.
        For i = 3 To FileStram.Length - 1
            FileStram.Position = i - 3
            FileStram.Read(TempArr, 0, 4)

            TempString = ""

            For j = 0 To TempArr.Count - 1
                TempString &= Chr(TempArr(j))
            Next

            ' Wenn der Boxname gefunden wurde, wird der Anfangspunkt der Kette 
            '  im Array an die Startpositions-Variable übergeben.
            If TempString.ToUpper = BoxName.ToUpper Then
                Pos = i - 3
                Exit For
            ElseIf i = FileStram.Length - 1 Then
                ' Wird die Box nicht gefundet, gebe Nothing zurück
                Return Nothing
                Exit Function
            End If
        Next

        ' Hier werden die Größenbytes der Box ausgelesen ...
        FileStram.Position = Pos - 4
        FileStram.Read(TempArr, 0, 4)

        ' ... ausgerechnet und an die Längenvariable (Länge in Bytes) übergeben. 
        Array.Reverse(TempArr)
        Len = BitConverter.ToInt32(TempArr, 0)

        ' Jetzt wird nur noch die Leseposition an die Stelle gesetzt, an der der 
        '  Inhalt der Box beginnt und die Rückgabebytes auf die richtige Größe 
        '  gebracht.
        FileStram.Position = Pos + 4
        ReDim ReturnBytes(Len - 9)
        ' Hier wird der Inhalt der Box ausgelesen (Len-8, da die Größe 8 Bytes 
        '  für größenangabe und Boxname enthält)
        FileStram.Read(ReturnBytes, 0, Len - 8)

        Return ReturnBytes
    End Function

    ' Hier wird eine Box aus einem Byte-Array in ein Byte-Array eingelesen
    '  (ähnlich ReadBox)
    Private Function ReadChildBox(ByVal ChildBoxName As String, _
                                  ByVal ParentBoxData() As Byte) As Byte()
        Dim ReturnBytes() As Byte
        Dim Pos As Long
        Dim temparr(3) As Byte
        Dim TempString As String = ""
        Dim Len As Long

        If ParentBoxData Is Nothing Then
            Return Nothing
        End If

        For i = 3 To ParentBoxData.Length - 1
            TempString = ""

            For j = 3 To 0 Step -1
                TempString &= Chr(ParentBoxData(i - j))
            Next

            If TempString.ToUpper = ChildBoxName.ToUpper Then
                Pos = i - 3
                Exit For
            ElseIf i = ParentBoxData.Length - 1 Then
                Return Nothing
                Exit Function
            End If
        Next

        For i = Pos - 4 To Pos - 1
            temparr(i - (Pos - 4)) = ParentBoxData(i)
        Next

        Array.Reverse(temparr)
        Len = BitConverter.ToInt32(temparr, 0)

        ReDim ReturnBytes(Len - 9)
        For i = Pos + 4 To Pos - 5 + Len
            ReturnBytes(i - (Pos + 4)) = ParentBoxData(i)
        Next

        Return ReturnBytes
    End Function

    'Mit dieser Funktion wird der zur GenreID gehorende String ermittelt
    Private Function GetGenreString(ByVal GenreID As Integer) As String
        Dim AvailableGenres() As String = {"Blues", "Classic Rock", "Country", _
            "Dance", "Disco", "Funk", "Grunge", "Hip - Hop", "Jazz", "Metal", _
            "New Age", "Oldies", "Other", "Pop", "R&B", "Rap", "Reggae", _
            "Rock", "Techno", "Industrial", "Alternative", "Ska", _
            "Death Metal", "Pranks", "Soundtrack", "Euro -Techno", "Ambient", _
            "Trip -Hop", "Vocal", "Jazz Funk", "Fusion", "Trance", _
            "Classical", "Instrumental", "Acid", "House", "Game", _
            "Sound Clip", "Gospel", "Noise", "AlternRock", "Bass", "Soul", _
            "Punk", "Space", "Meditative", "Instrumental Pop", _
            "Instrumental Rock", "Ethnic", "Gothic", "Darkwave", _
            "Techno-Industrial", "Electronic", "Pop-Folk", "Eurodance", _
            "Dream", "Southern Rock", "Comedy", "Cult", "Gangsta", "Top 40", _
            "Christian Rap", "Pop/Funk", "Jungle", "Native American", _
            "Cabaret", "New Wave", "Psychadelic", "Rave", "Showtunes", _
            "Trailer", "Lo - Fi", "Tribal", "Acid Punk", "Acid Jazz", "Polka", _
            "Retro", "Musical", "Rock & Roll", "Hard Rock", "Folk", _
            "Folk/Rock", "National Folk", "Swing", "Bebob", "Latin", _
            "Revival", "Celtic", "Bluegrass", "Avantgarde", "Gothic Rock", _
            "Progressive Rock", "Psychedelic Rock", "Symphonic Rock", _
            "Slow Rock", "Big Band", "Chorus", "Easy Listening", "Acoustic", _
            "Humour", "Speech", "Chanson", "Opera", "Chamber Music", "Sonata", _
            "Symphony", "Booty Bass", "Primus", "Porn Groove", "Satire", _
            "Slow Jam", "Club", "Tango", "Samba", "Folklore", "Ballad", _
            "Power Ballad", "Rhythmic Soul", "Freestyle", "Duet", "Punk Rock", _
            "Drum Solo", "A Cappella", "Euro - House", "Dance Hall", "Goa", _
            "Drum & Bass", "Club - House", "Hardcore", "Terror", "Indie", _
            "BritPop", "Negerpunk", "Polsk Punk", "Beat", _
            "Christian Gangsta Rap", "Heavy Metal", "Black Metal", _
            "Crossover", "Contemporary Christian", "Christian Rock", _
            "Merengue", "Salsa", "Thrash Metal", "Anime", "JPop", "Synthpop"}
        Try
            Return AvailableGenres(GenreID)
        Catch
            Return " "
        End Try
    End Function

    ReadOnly Property Year As String
        Get
            Dim RetString As String = ""

            cDay = ReadChildBox("©day", ILST)
            cDay = ReadChildBox("data", cDay)

            If cDay Is Nothing Then Return ""

            For i = 8 To cDay.Length - 1
                If InStr("0123456789", Chr(cDay(i))) > 0 Then
                    RetString &= Chr(cDay(i))
                End If
            Next

            Return RetString
        End Get
    End Property

    ReadOnly Property Title As String
        Get
            Dim RetString As String = ""

            cNam = ReadChildBox("©nam", ILST)
            cNam = ReadChildBox("data", cNam)

            If cNam Is Nothing Then Return ""

            For i = 8 To cNam.Length - 1
                RetString &= Chr(cNam(i))
            Next

            Return RetString
        End Get
    End Property

    ReadOnly Property Album As String
        Get
            Dim RetString As String = ""

            cAlb = ReadChildBox("©alb", ILST)
            cAlb = ReadChildBox("data", cAlb)

            If cAlb Is Nothing Then Return ""

            For i = 8 To cAlb.Length - 1
                RetString &= Chr(cAlb(i))
            Next

            Return RetString
        End Get
    End Property

    ReadOnly Property Artist As String
        Get
            Dim RetString As String = ""

            cArt = ReadChildBox("©art", ILST)
            cArt = ReadChildBox("data", cArt)

            If cArt Is Nothing Then Return ""

            For i = 8 To cArt.Length - 1
                RetString &= Chr(cArt(i))
            Next

            Return RetString
        End Get
    End Property

    ReadOnly Property Genre As String
        Get
            Dim RetString As String = ""

            cGen = ReadChildBox("gnre", ILST)
            cGen = ReadChildBox("data", cGen)

            If cGen Is Nothing Then
                cGen = ReadChildBox("©gen", ILST)
                cGen = ReadChildBox("data", cGen)

                If cGen Is Nothing Then Return ""

                For i = 8 To cGen.Length - 1
                    RetString &= Chr(cGen(i))
                Next

                Return RetString
            End If

            RetString = GetGenreString(cGen(cGen.Length - 1))

            Return RetString
        End Get
    End Property
End Class
